'use strict';

const path = require('path');
const ejs = require('ejs')
const express = require('express');
const {P2PSub} = require('p2psub');
const pvejs = require('./utils/pvejs');


// Set up the express app.
const app = express();

app.onListen = [];

// Allow the express app to be exported into other files. 
module.exports = app;

// Build the conf object from the conf files.
app.conf = require('./conf/conf');

app.p2p = new P2PSub({...app.conf.p2p, preBroadcast: function(data){
  let thisData = {...data}
  delete thisData.__noSocket;
  return thisData;
}});

app.onListen.push(function(){
  app.p2p.subscribe(/./g, function(data, topic){
    if(data.__noSocket) return;

    app.io.emit('P2PSub', { topic, data })
  });                                 

  app.io.on('connection', (socket) => {
    // console.log('connection io', socket)
    socket.on('P2PSub', (msg) => {
      msg.data.__noSocket = true;
      console.log('connection ondata', msg)
      app.p2p.publish(msg.topic, msg.data);
      socket.broadcast.emit('P2PSub', msg)

    });
  });

});

// Hold onto the auth middleware 
const middleware = require('./middleware/auth');

// load the JSON parser middleware. Express will parse JSON into native objects
// for any request that has JSON in its content type. 
app.use(express.json());

// Set up the templating engine to build HTML for the front end.
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

// Have express server static content( images, CSS, browser JS) from the public
// local folder.
app.use('/static', express.static(path.join(__dirname, 'public')))

// Routes for front end content.
app.use('/', require('./routes/index'));

// API routes for authentication. 
app.use('/api/auth',  require('./routes/auth'));

// API routes for working with users. All endpoints need to be have valid user.
app.use('/api/user', middleware.auth, require('./routes/user'));

app.use('/api/token', middleware.auth, require('./routes/token'));

if(app.conf.proxmox){
  (async function(){
    app.api = await pvejs(app.conf.proxmox);
    setInterval(async function(){
      try{
        let res = await app.api.GET({path: '/cluster/resources'});
        let types = {};

        for(let item of res.json){
          if(!types[item.type]){
             types[item.type] = [];
          }
          types[item.type].push(item);
        }

        app.p2p.publish('proxmox-cluster', {vpnSite: app.conf.vpnSite, data: types});

      }catch(error){
        console.error('proxmox pub', error)
      }

    }, 10000);
  })()
  
}


// Catch 404 and forward to error handler. If none of the above routes are
// used, this is what will be called.
app.use(function(req, res, next) {
  var err = new Error('Not Found');
  err.message = 'Page not found'
  err.status = 404;
  next(err);
});

// Error handler. This is where `next()` will go on error
app.use(function(err, req, res, next) {
  console.error(err.status || res.status, err.name, req.method, req.url);
  console.error(err.message);
  console.error(err.stack);
  console.error('=========================================');

  res.status(err.status || 500);
  res.json({name: err.name, message: err.message});
});
